Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.ref
Class PhantomReference<T>

    java.lang.Object
      java.lang.ref.Reference<T>
          java.lang.ref.PhantomReference<T>

    public class PhantomReference<T>

extends Reference<T>

Phantom reference objects, which are enqueued after the collector determines that their referents may otherwise be reclaimed. Phantom references are most often used for scheduling pre-mortem cleanup actions in a more flexible way than is possible with the Java finalization mechanism.

If the garbage collector determines at a certain point in time that the referent of a phantom reference is phantom reachable, then at that time or at some later time it will enqueue the reference.

In order to ensure that a reclaimable object remains so, the referent of a phantom reference may not be retrieved: The `get` method of a phantom reference always returns `null`.

Unlike soft and weak references, phantom references are not automatically cleared by the garbage collector as they are enqueued. An object that is reachable via phantom references will remain so until all such references are cleared or themselves become unreachable.

Since:
  1.2

Constructor Summary
`PhantomReference(T referent, ReferenceQueue<? super T> q)` Creates a new phantom reference that refers to the given object and is registered with the given queue.

Method Summary
`T` | `get()` Returns this reference object's referent.

Methods inherited from class java.lang.ref.Reference
`clear, enqueue, isEnqueued`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PhantomReference

    public PhantomReference(T referent,
                            ReferenceQueue<? super T> q)

  Creates a new phantom reference that refers to the given object and is registered with the given queue.

  It is possible to create a phantom reference with a `null` queue, but such a reference is completely useless: Its `get` method will always return null and, since it does not have a queue, it will never be enqueued.

  Parameters:
    `referent` - the object the new phantom reference will refer to
    `q` - the queue with which the reference is to be registered, or `null` if registration is not required

Method Detail

### get

    public T get()

  Returns this reference object's referent. Because the referent of a phantom reference is always inaccessible, this method always returns `null`.

  Overrides:
    `get` in class `Reference<T>`
  Returns:
    `null`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.